#include "timer.h"

Timer::Timer()
{
	m_startTime = 0;
	m_pauseTime = 0;
	m_paused = false;
}

void Timer::Start()
{
	m_startTime = clock();
}

clock_t Timer::GetTime()
{
	if(m_paused) return m_pauseTime;
	return clock()-m_startTime;
}

void Timer::Pause() {
	if(!m_paused) {
		m_pauseTime = GetTime();
		m_paused = true;	
	}
}

void Timer::Resume() {
	if(m_paused) {
		m_paused = false;
		clock_t actTime = GetTime();
		m_startTime += actTime - m_pauseTime;
	}
}